//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop


#include "U_CopyThread.h"
#include "U_FileBackUp.h"
//#define __PSAPI__
#include "Od_Functions.h"
#include <IdGlobal.hpp>
#pragma package(smart_init)


//---------------------------------------------------------------------------

//   Important: Methods and properties of objects in VCL can only be
//   used in a method called using Synchronize, for example:
//
//      Synchronize(UpdateCaption);
//
//   where UpdateCaption could look like:
//
//      void __fastcall CopyThread::UpdateCaption()
//      {
//        Form1->Caption = "Updated in a thread";
//      }
//---------------------------------------------------------------------------
int CurrentPos;
DWORD CALLBACK CopyProgressRoutine(     LARGE_INTEGER TotalFileSize,
                                        LARGE_INTEGER TotalBytesTransferred,
                                        LARGE_INTEGER StreamSize,
                                        LARGE_INTEGER StreamBytesTransferred,
                                        DWORD dwStreamNumber,
                                        DWORD dwCallbackReason,
                                        HANDLE hSourceFile,
                                        HANDLE hDestinationFile,
                                        LPVOID lpData);

//---------------------------------------------------------------------------
__fastcall CopyThread::CopyThread(bool CreateSuspended)
    : TThread(CreateSuspended)
{
	count = 0;
}
//---------------------------------------------------------------------------
void __fastcall CopyThread::Execute()
{
    StatusCaption = "   ...";
    Synchronize(UpdateCaption);

    AnsiString SourceFolder = F_FileBackUp->Ed_Source->Text;
    AnsiString DestFolder = F_FileBackUp->Ed_Destination->Text;

    TSearchRec sr;
    TotalSize = 0;
    if(!(SourceFolder.IsEmpty())||(DestFolder.IsEmpty())){

        if(!FindFirst(SourceFolder+"\\*.*",faAnyFile,sr))
            do{
                if(Terminated){
                    FindClose(sr);
                    return;
                }
                if(!(sr.Name=="."  || sr.Name==".."))//    
                    if(sr.Attr == faDirectory){
                        //
                    }
                    else{ //   
                        int SDate, DDate;
                        SDate = FileAge(SourceFolder+"\\"+sr.Name);
                        DDate = FileAge(DestFolder+"\\"+sr.Name);
                        if(SDate!=DDate){
                            SCopy SC;
                            SC.SFile = SourceFolder+"\\"+sr.Name;
                            SC.DFile = DestFolder+"\\"+sr.Name;
                            SC.Size = FileSizeByName(SC.SFile);
                            TotalSize += SC.Size;
                            FilesCopy.push_back(SC);

                            AddingFile = sr.Name;
                            Synchronize(AddFile);
                        }
                    }
            }
            while (!FindNext(sr));//  ,    
            FindClose(sr);
    }
    StatusCaption = "   ...";
    Synchronize(UpdateCaption);

    Synchronize(SetTotal);
    for(unsigned int counter=0; counter<FilesCopy.size(); counter++){
        if(Terminated){
            break;
        }

        StatusCaption = "  " + ExtractFileName(FilesCopy[counter].SFile);
        Synchronize(UpdateCaption);
        CurrentSize = FilesCopy[counter].Size;
        Synchronize(SetCurrent);

        if(!CopyFileEx( FilesCopy[counter].SFile.c_str(),
                        FilesCopy[counter].DFile.c_str(),
                        CopyProgressRoutine,
                        NULL,
                        NULL,
                        NULL)) ShowMessage("Error copying file " + FilesCopy[counter].SFile);
        CopiedFile = counter;
        Synchronize(ChekFile);

    }

    StatusCaption = " ";
    Synchronize(UpdateCaption);
}
//---------------------------------------------------------------------------
void __fastcall CopyThread::UpdateCaption()
{
    F_FileBackUp->StatusBar1->SimpleText = StatusCaption;
}
//---------------------------------------------------------------------------
void __fastcall CopyThread::AddFile()
{
    F_FileBackUp->LB_FilesPassed->Items->Insert(F_FileBackUp->LB_FilesPassed->Items->Count,AddingFile);
    SendMessage(F_FileBackUp->LB_FilesPassed->Handle,WM_VSCROLL,SB_BOTTOM,NULL);

}
//---------------------------------------------------------------------------
void __fastcall CopyThread::SetTotal()
{
    F_FileBackUp->ProgressBar2->Max = TotalSize;
    SendMessage(F_FileBackUp->LB_FilesPassed->Handle,WM_VSCROLL,SB_TOP,NULL);
}
//---------------------------------------------------------------------------
void __fastcall CopyThread::SetCurrent()
{
    F_FileBackUp->ProgressBar1->Max = CurrentSize;
}
//---------------------------------------------------------------------------
DWORD CALLBACK CopyProgressRoutine(
                                    LARGE_INTEGER TotalFileSize,
                                    LARGE_INTEGER TotalBytesTransferred,
                                    LARGE_INTEGER StreamSize,
                                    LARGE_INTEGER StreamBytesTransferred,
                                    DWORD dwStreamNumber,
                                    DWORD dwCallbackReason,
                                    HANDLE hSourceFile,
                                    HANDLE hDestinationFile,
                                    LPVOID lpData
){

    CurrentPos = (int)(TotalBytesTransferred.QuadPart);
    F_FileBackUp->CT->SynPos();
    return PROGRESS_CONTINUE;
}
//---------------------------------------------------------------------------
void __fastcall CopyThread::SetPosition()
{

    F_FileBackUp->ProgressBar2->Position = F_FileBackUp->ProgressBar2->Position + CurrentPos - F_FileBackUp->ProgressBar1->Position;
    F_FileBackUp->ProgressBar1->Position = CurrentPos;
}
//---------------------------------------------------------------------------
void __fastcall CopyThread::SynPos(){

    Synchronize(SetPosition);
}
//---------------------------------------------------------------------------
void __fastcall CopyThread::ChekFile(){

    count++;
    F_FileBackUp->LB_FilesPassed->Items->Strings[CopiedFile] = F_FileBackUp->LB_FilesPassed->Items->Strings[CopiedFile]+" - OK";
    for(int files=0; files<count; files++)
    	SendMessage(F_FileBackUp->LB_FilesPassed->Handle,WM_VSCROLL,SB_LINEDOWN,NULL);
}
//---------------------------------------------------------------------------
