//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include <Registry.hpp>
#include <FileCtrl.hpp>
#include "U_FileBackUp.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TF_FileBackUp *F_FileBackUp;
//---------------------------------------------------------------------------
__fastcall TF_FileBackUp::TF_FileBackUp(TComponent* Owner)
    : TForm(Owner)
{

    TRegistry *Reg = new TRegistry;
    try{
        Reg->RootKey = HKEY_CURRENT_USER;
        if(Reg->OpenKey("\\Software\\FileBackUp\\Shemas", true)){
            Reg->CloseKey();
        }
        if(Reg->OpenKey("\\Software\\FileBackUp",false)){
            try{
                ShemaIndex = Reg->ReadInteger("DefaultShema");
            }
            catch(...){
                BB_DefaultShema->Enabled = false;
                ShemaIndex = -1;
            }
            Reg->CloseKey();
        }
    }
    catch(Exception &E){
        MessageBox(Handle,E.Message.c_str(),"   ",MB_OK|MB_ICONSTOP);
        Reg->CloseKey();
        delete Reg;
        Application->Terminate();
    }
    delete Reg;

    RefreshShemas(true);

    CB_Priority->ItemIndex = 3;

    for(int counter=1; counter<ParamCount()+1; counter++){
        if(ParamStr(counter)=="-S"){
            for(int lbc=0; lbc<CB_Shema->Items->Count; lbc++){
                CB_Shema->ItemIndex = lbc;
                if(CB_Shema->Text == ParamStr(counter+1)){
                    Ed_Source->Text = SourcePath[CB_Shema->ItemIndex];
                    Ed_Destination->Text = DestPath[CB_Shema->ItemIndex];
                    break;
                }
                CB_Shema->ItemIndex = -1;
            }
        }
        if(ParamStr(counter)=="-Source"){
            Ed_Source->Text = ParamStr(counter+1);
        }
        if(ParamStr(counter)=="-Destination"){
            Ed_Destination->Text = ParamStr(counter+1);
        }
        if(ParamStr(counter)=="-auto"){
            Auto = true;
        }
    }

}
//---------------------------------------------------------------------------
void __fastcall TF_FileBackUp::BB_ExitClick(TObject *Sender)
{
    Application->Terminate();    
}
//---------------------------------------------------------------------------


void __fastcall TF_FileBackUp::BB_SaveShemaClick(TObject *Sender)
{
    if(CB_Shema->Text.IsEmpty()){
        ShowMessage("   ");
        return;
    }
    if(Ed_Source->Text.IsEmpty()){
        ShowMessage("   ");
        return;
    }
    if(Ed_Destination->Text.IsEmpty()){
        ShowMessage("   ");
        return;
    }

    TRegistry *Reg = new TRegistry();
    try{
        Reg->RootKey = HKEY_CURRENT_USER;
        if(Reg->OpenKey("\\Software\\FileBackUp\\Shemas", false)){
            TStringList *SL = new TStringList();
            Reg->GetKeyNames(SL);

            for(int count=1; count<SL->Count+1; count++){
                Reg->OpenKey("\\Software\\FileBackUp\\Shemas\\" + IntToStr(count),false);
                if(CB_Shema->Text == Reg->ReadString("ShemaName")){
                    Reg->WriteString("Source",Ed_Source->Text);
                    Reg->WriteString("Dest",Ed_Destination->Text);
                    Reg->CloseKey();
                    delete Reg;
                    return;
                }
            }

            if(SL->Count<10){
                TRegistry *RegShema = new TRegistry();
                RegShema->RootKey = HKEY_CURRENT_USER;
                RegShema->CreateKey("\\Software\\FileBackUp\\Shemas\\" + IntToStr(SL->Count+1));
                for(int count=SL->Count; count>0; count--){
                    AnsiString Source, Dest, ShemaName;
                    RegShema->OpenKey("\\Software\\FileBackUp\\Shemas\\" + IntToStr(count),false);
                    ShemaName = RegShema->ReadString("ShemaName");
                    Source = RegShema->ReadString("Source");
                    Dest = RegShema->ReadString("Dest");
                    RegShema->OpenKey("\\Software\\FileBackUp\\Shemas\\" + IntToStr(count+1),false);
                    RegShema->WriteString("ShemaName",ShemaName);
                    RegShema->WriteString("Source",Source);
                    RegShema->WriteString("Dest",Dest);
                }
                RegShema->OpenKey("\\Software\\FileBackUp\\Shemas\\1",false);
                RegShema->WriteString("ShemaName",CB_Shema->Text);
                RegShema->WriteString("Source",Ed_Source->Text);
                RegShema->WriteString("Dest",Ed_Destination->Text);
                RegShema->CloseKey();
                delete RegShema;
                if(ShemaIndex!=-1){
                    ShemaIndex++;
                    BB_DefaultShemaClick(this);
                    AddIndex = 0;
                    ShemaIndex = AddIndex;
                }
            }
            else{
                TRegistry *RegShema = new TRegistry();
                RegShema->RootKey = HKEY_CURRENT_USER;
                for(int count=9; count>0; count--){
                    AnsiString Source, Dest, ShemaName;
                    RegShema->OpenKey("\\Software\\FileBackUp\\Shemas\\" + IntToStr(count),false);
                    ShemaName = RegShema->ReadString("ShemaName");
                    Source = RegShema->ReadString("Source");
                    Dest = RegShema->ReadString("Dest");
                    RegShema->OpenKey("\\Software\\FileBackUp\\Shemas\\" + IntToStr(count+1),false);
                    RegShema->WriteString("ShemaName",ShemaName);
                    RegShema->WriteString("Source",Source);
                    RegShema->WriteString("Dest",Dest);
                }
                RegShema->OpenKey("\\Software\\FileBackUp\\Shemas\\1",false);
                RegShema->WriteString("ShemaName",CB_Shema->Text);
                RegShema->WriteString("Source",Ed_Source->Text);
                RegShema->WriteString("Dest",Ed_Destination->Text);
                RegShema->CloseKey();
                delete RegShema;
                if(ShemaIndex!=-1 && ShemaIndex!=9){
                    ShemaIndex++;
                    BB_DefaultShemaClick(this);
                    AddIndex = 0;
                    ShemaIndex = AddIndex;
                }
                else{
                    Reg->OpenKey("\\Software\\FileBackUp",false);
                    if(Reg->ValueExists("DefaultShema"))
                        Reg->DeleteValue("DefaultShema");
                    ShemaIndex=-1;
                    BB_DefaultShemaClick(this);
                }
            }
            delete SL;
            Reg->CloseKey();
        }
    }
    catch(Exception &E){
        MessageBox(Handle,E.Message.c_str(),"   ",MB_OK|MB_ICONSTOP);
        Reg->CloseKey();
        delete Reg;
        Application->Terminate();
    }
    delete Reg;

    RefreshShemas(false);
    BB_DefaultShema->Enabled = true;
    
}
//---------------------------------------------------------------------------
void __fastcall TF_FileBackUp::RefreshShemas(bool SetDefault)
{
    CB_Shema->Clear();
    TRegistry *Reg = new TRegistry;
    try{
        Reg->RootKey = HKEY_CURRENT_USER;
        if(Reg->OpenKey("\\Software\\FileBackUp\\Shemas", false)){
            TStringList *SL = new TStringList();
            Reg->GetKeyNames(SL);
            for(int count=1; count<SL->Count+1; count++){
                Reg->OpenKey("\\Software\\FileBackUp\\Shemas\\" + IntToStr(count),false);
                CB_Shema->AddItem(Reg->ReadString("ShemaName"),NULL);
                SourcePath[count-1] = Reg->ReadString("Source");
                DestPath[count-1] = Reg->ReadString("Dest");
            }
            delete SL;
            Reg->CloseKey();
        }
    }
    catch(Exception &E){
        MessageBox(Handle,E.Message.c_str(),"   ",MB_OK|MB_ICONSTOP);
        Reg->CloseKey();
        delete Reg;
        Application->Terminate();
    }
    delete Reg;
    if(SetDefault){
        if(ShemaIndex != -1){
            CB_Shema->ItemIndex = ShemaIndex;
            Ed_Source->Text = SourcePath[CB_Shema->ItemIndex];
            Ed_Destination->Text = DestPath[CB_Shema->ItemIndex];
        }
    }
    else{
        CB_Shema->ItemIndex = AddIndex;
        Ed_Source->Text = SourcePath[CB_Shema->ItemIndex];
        Ed_Destination->Text = DestPath[CB_Shema->ItemIndex];
    }
}
//---------------------------------------------------------------------------

void __fastcall TF_FileBackUp::CB_ShemaSelect(TObject *Sender)
{
    Ed_Source->Text = SourcePath[CB_Shema->ItemIndex];
    Ed_Destination->Text = DestPath[CB_Shema->ItemIndex];
    ShemaIndex = CB_Shema->ItemIndex;
    BB_DefaultShema->Enabled = true;
}
//---------------------------------------------------------------------------


void __fastcall TF_FileBackUp::BB_DefaultShemaClick(TObject *Sender)
{
    if(ShemaIndex==-1) return;
    TRegistry *Reg = new TRegistry;
    try{
        Reg->RootKey = HKEY_CURRENT_USER;
        if(Reg->OpenKey("\\Software\\FileBackUp", false)){
            Reg->WriteInteger("DefaultShema",ShemaIndex);
            Reg->CloseKey();
        }
    }
    catch(Exception &E){
        MessageBox(Handle,E.Message.c_str(),"   ",MB_OK|MB_ICONSTOP);
        Reg->CloseKey();
        delete Reg;
        Application->Terminate();
    }
    delete Reg;

}
//---------------------------------------------------------------------------

void __fastcall TF_FileBackUp::CB_ShemaChange(TObject *Sender)
{
    BB_DefaultShema->Enabled = false;
}
//---------------------------------------------------------------------------

void __fastcall TF_FileBackUp::BitBtn1Click(TObject *Sender)
{
    AnsiString Dir = "";
    if (SelectDirectory("  ", "",Dir)){
        Ed_Source->Text = Dir;
    }

}
//---------------------------------------------------------------------------

void __fastcall TF_FileBackUp::BitBtn2Click(TObject *Sender)
{
    AnsiString Dir = "";
    if (SelectDirectory("  ", "",Dir)){
        Ed_Destination->Text = Dir;
    }
}
//---------------------------------------------------------------------------


void __fastcall TF_FileBackUp::BB_BackUpClick(TObject *Sender)
{
    if(Ed_Source->Text.IsEmpty()){
        ShowMessage("  ");
        return;
    }
    if(Ed_Destination->Text.IsEmpty()){
        ShowMessage("  ");
        return;
    }

    LB_FilesPassed->Clear();

    CS.Ed_Source = Ed_Source->Enabled;
    CS.Ed_Destination = Ed_Destination->Enabled;
    CS.BitBtn1 = BitBtn1->Enabled;
    CS.BitBtn2 = BitBtn2->Enabled;
    CS.LB_FilesPassed = LB_FilesPassed->Enabled;
    CS.CB_Shema = CB_Shema->Enabled; 
    CS.CB_Priority = CB_Priority->Enabled;
    CS.BB_SaveShema = BB_SaveShema->Enabled;
    CS.BB_DefaultShema = BB_DefaultShema->Enabled;

    Ed_Source->Enabled = false;
    Ed_Destination->Enabled = false;
    BitBtn1->Enabled = false;
    BitBtn2->Enabled = false;
    //LB_FilesPassed->Enabled = false;
    CB_Shema->Enabled = false;
    CB_Priority->Enabled = false;
    BB_SaveShema->Enabled = false;
    BB_DefaultShema->Enabled = false;

    BB_BackUp->Enabled = false;
    BB_Exit->Enabled = false;
    if(!Auto) BB_Cansel->Enabled = true;
    CT = new CopyThread(true);

    switch (CB_Priority->ItemIndex)
    {
          case 0: CT->Priority = tpIdle;
          break;
          case 1: CT->Priority = tpLowest;
          break;
          case 2: CT->Priority = tpLower;
          break;
          case 3: CT->Priority = tpNormal;
          break;
          case 4: CT->Priority = tpHigher;
          break;
          case 5: CT->Priority = tpHighest;
          break;
          case 6: CT->Priority = tpTimeCritical;
    }

    CT->FreeOnTerminate = true;
    CT->OnTerminate = CTTerminate;
    CT->Resume();


}
//---------------------------------------------------------------------------

void __fastcall TF_FileBackUp::BB_CanselClick(TObject *Sender)
{
    if(CT)
        CT->Terminate();
    /*BB_Cansel->Enabled = false;
    Ed_Source->Enabled = CS.Ed_Source;
    Ed_Destination->Enabled = CS.Ed_Destination;
    BitBtn1->Enabled = CS.BitBtn1;
    BitBtn2->Enabled = CS.BitBtn2;
    LB_FilesPassed->Enabled = CS.LB_FilesPassed;
    CB_Shema->Enabled = CS.CB_Shema;
    CB_Priority->Enabled = CS.CB_Priority;
    BB_SaveShema->Enabled = CS.BB_SaveShema;
    BB_DefaultShema->Enabled = CS.BB_DefaultShema;*/
}
//---------------------------------------------------------------------------


void __fastcall TF_FileBackUp::CTTerminate(TObject *Sender)
{
    BB_Cansel->Enabled = false;
    BB_BackUp->Enabled = true;
    BB_Exit->Enabled = true;
    Ed_Source->Enabled = CS.Ed_Source;
    Ed_Destination->Enabled = CS.Ed_Destination;
    BitBtn1->Enabled = CS.BitBtn1;
    BitBtn2->Enabled = CS.BitBtn2;
    //LB_FilesPassed->Enabled = CS.LB_FilesPassed;
    CB_Shema->Enabled = CS.CB_Shema;
    CB_Priority->Enabled = CS.CB_Priority;
    BB_SaveShema->Enabled = CS.BB_SaveShema;
    BB_DefaultShema->Enabled = CS.BB_DefaultShema;
    ProgressBar1->Position = 0;
    ProgressBar2->Position = 0;
    if(Auto) Application->Terminate();
}
//---------------------------------------------------------------------------
void __fastcall TF_FileBackUp::FormCloseQuery(TObject *Sender,
      bool &CanClose)
{
    if(!BB_Exit->Enabled) CanClose = false;    
}
//---------------------------------------------------------------------------

void __fastcall TF_FileBackUp::FormShow(TObject *Sender)
{
    if(Auto) BB_BackUpClick(this);
}
//---------------------------------------------------------------------------

